<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>POIT</title>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='styles.css') }}">
    
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/3.0.5/socket.io.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/chartjs-adapter-moment@1.0.0"></script>
    <script src="https://cdn.jsdelivr.net/npm/gaugeJS@1.3.8/dist/gauge.min.js"></script>

</head>
<body>
        <header>
            <h1>POIT</h1>
        </header>

        <div>  
            <div class="controls">
                <button class="control-button" id="control-open">OPEN</button>
                <button class="control-button" id="control-start">START</button>
                <button class="control-button" id="control-stop">STOP</button>
                <button class="control-button" id="control-close">CLOSE</button>
                <button class="control-button" id="control-json">VIEW JSON</button>
                <button class="control-button" id="control-db">VIEW DATABASE</button>
                <button class="control-button" id="control-humidity">START HUMIDITY</button>
                <button class="control-button" id="control-temperature">START TEMPERATURE</button>
            </div>
        </div>
        <div class="flex-container">
            <div class="left">
                <div class="graph-container">
                    <div>
                        <canvas id="tempGraph"></canvas>
                    </div>
                    <div>
                        <canvas id="tempGauge"></canvas>
                    </div>
                </div>
                <div class="graph-container">
                    <div>
                        <canvas id="humidityGraph"></canvas>
                    </div>
                    <div>
                        <canvas id="humidityGauge"></canvas>
                    </div>
                </div>
            </div>
            <div class="right">
                <div id="monitor-section">
                    <div id="sensor-display">
                        <div id="sensor-data"></div>
                    </div>
                </div>
            </div>
    </div>
    <script type="text/javascript">
        $(document).ready(function() {
            var socket = io();
            var showTempLive = false;
            var showHumidityLive = false;
            var tempData = [];
            var humidData = [];
            
            var ctx = document.getElementById('tempGraph').getContext('2d');
            var tempGraph = new Chart(ctx, {
                type: 'line',
                data: {
                    labels: [],
                    datasets: [{
                        label: 'Temperature (°C)',
                        data: tempData,
                        borderColor: 'rgba(255, 159, 64, 1)',
                        backgroundColor: 'rgba(255, 159, 64, 0.2)',
                        borderWidth: 2,
                        fill: true
                    }]
                },
                options: {
                    plugins: {
                        legend: {
                            display: true
                        }
                    },
                    scales: {
                        x: {
                            type: 'time',
                            time: {
                                unit: 'second'
                            },
                            title: {
                                display: true,
                                text: 'Time',
                                color: 'rgba(75, 192, 192, 1)'
                            },
                            ticks: {
                                color: 'rgba(75, 192, 192, 1)'
                            }
                        },
                        y: {
                            title: {
                                display: true,
                                text: 'Temperature (°C)',
                                color: 'rgba(75, 192, 192, 1)'
                            },
                            ticks: {
                                color: 'rgba(75, 192, 192, 1)'
                            }
                        }
                    }
                }
            });
    
            var cth = document.getElementById('humidityGraph').getContext('2d');
            var humidityGraph = new Chart(cth, {
                type: 'line',
                data: {
                    labels: [],
                    datasets: [{
                        label: 'Humidity (%)',
                        data: humidData,
                        borderColor: 'rgba(54, 162, 235, 1)',
                        backgroundColor: 'rgba(54, 162, 235, 0.2)',
                        borderWidth: 2,
                        fill: true
                    }]
                },
                options: {
                    plugins: {
                        legend: {
                            display: true
                        }
                    },
                    scales: {
                        x: {
                            type: 'time',
                            time: {
                                unit: 'second'
                            },
                            title: {
                                display: true,
                                text: 'Time',
                                color: 'rgba(153, 102, 255, 1)'
                            },
                            ticks: {
                                color: 'rgba(153, 102, 255, 1)'
                            }
                        },
                        y: {
                            title: {
                                display: true,
                                text: 'Humidity (%)',
                                color: 'rgba(153, 102, 255, 1)'
                            },
                            ticks: {
                                color: 'rgba(153, 102, 255, 1)'
                            }
                        }
                    }
                }
            });
    
            // GAUGEJS TEMPERATURE GAUGE 

            var target = document.getElementById('tempGauge');
    
            target.width = target.clientWidth;
            target.height = target.clientHeight;
    
            var tempGauge = new Gauge(target).setOptions({
                angle: -0.3, 
                lineWidth: 0.2,
                radiusScale: 0.8,
                pointer: {
                    length: 0.6, 
                    strokeWidth: 0.035, 
                    color: 'rgba(255, 99, 132, 1)' 
                },
                limitMax: false,
                limitMin: false,
                renderTicks: {
                    divisions: 5,
                    divWidth: 1.1,
                    divLength: 0.7,
                    divColor: 'rgba(255, 99, 132, 1)' ,
                    subDivisions: 3,
                    subLength: 0.5,
                    subWidth: 0.6,
                    subColor: 'rgba(255, 99, 132, 1)' 
                },
                staticLabels: {
                    font: "10px sans-serif", 
                    labels: [0, 10, 20, 30, 40],  
                    color: 'rgba(0, 0, 0, 0.8)',  
                    fractionDigits: 0  
                },
                staticZones: [
                    {strokeStyle: 'rgba(255, 0, 0, 0.3)', min: 0, max: 40}, 
                ],
            });
            tempGauge.maxValue = 40; 
            tempGauge.setMinValue(0);  
            tempGauge.animationSpeed = 32; 
            tempGauge.set(0);
            
            // GAUGEJS HUMIDITY GAUGE 

            var target2 = document.getElementById('humidityGauge');
    
            target2.width = target2.clientWidth;
            target2.height = target2.clientHeight;
    
            var humidityGauge = new Gauge(target2).setOptions({
                angle: -0.3, 
                lineWidth: 0.2,
                radiusScale: 0.8,
                pointer: {
                    length: 0.6, 
                    strokeWidth: 0.035, 
                    color: 'rgba(54, 162, 235, 1)' 
                },
                limitMax: false,
                limitMin: false,
                renderTicks: {
                    divisions: 5,
                    divWidth: 1.1,
                    divLength: 0.7,
                    divColor: 'rgba(54, 162, 235, 1)' ,
                    subDivisions: 3,
                    subLength: 0.5,
                    subWidth: 0.6,
                    subColor: 'rgba(54, 162, 235, 1)' 
                },
                staticLabels: {
                    font: "10px sans-serif", 
                    labels: [0, 20, 40, 60, 80, 100],  
                    color: 'rgba(0, 0, 0, 0.8)',  
                    fractionDigits: 0  
                },
                staticZones: [
                    {strokeStyle: 'rgba(0, 0, 255, 0.3)', min: 0, max: 100}, 
                ],
            });
            humidityGauge.maxValue = 100; 
            humidityGauge.setMinValue(0);  
            humidityGauge.animationSpeed = 32; 
            humidityGauge.set(0); 
    
            socket.on('connect', function() {
                console.log('Connected to server');
            });
    
            socket.on('arduino_status', function(data) {
                let statusDiv = document.getElementById('status');
                statusDiv.innerHTML = `<p>~$: ${data.message}</p>`;
            });
    
            socket.on('sensor_data', function(data) {
                var now = new Date().getTime();
                let sensorDataDiv = document.getElementById('sensor-data'); 
                let newSensorData = `<p>HUMIDITY: ${data.humidity}; TEMPERATURE: ${data.temperature}</p>`;
                sensorDataDiv.innerHTML += newSensorData;
                sensorDataDiv.scrollTop = sensorDataDiv.scrollHeight;

                if (showTempLive) {   
                    tempGraph.data.labels.push(now);
                    tempGraph.data.datasets[0].data.push(data.temperature);
                    tempGraph.update();
                    tempGauge.set(data.temperature);  
                }
                if (showHumidityLive) {
                    humidityGraph.data.labels.push(now);
                    humidityGraph.data.datasets[0].data.push(data.humidity);
                    humidityGraph.update();
                    humidityGauge.set(data.humidity);
                }
            });

            function clearChart(chart) {
                chart.data.labels = [];
                chart.data.datasets.forEach(dataset => {
                    dataset.data = [];
                });
                chart.update();
            }
    
            $('#control-open').click(function() {
                fetch('/system_open', {method: 'POST'})
                .then(response => response.json())
                .catch(error => alert('Error: ' + error));
            });
    
            $('#control-start').click(function() {
                fetch('/monitor_start', {method: 'POST'})
                .then(response => response.json())
                .catch(error => alert('Error: ' + error));
            });
    
            $('#control-reset-temp').click(function() {
                clearChart(tempGraph); 
                showTempLive = !showTempLive; 
            });

            $('#control-close').click(function() {
                fetch('/system_disconnect', {method: 'POST'})
                .then(response => response.json())
                .catch(error => alert('Error: ' + error));
            });

            $('#control-stop').click(function() {
                fetch('/monitor_stop', {method: 'POST'})
                .then(response => response.json())
                .catch(error => alert('Error: ' + error));
            });

            $('#control-json').click(function() {
                clearChart(tempGraph);
                clearChart(humidityGraph);
                showTempLive = false; 
                showHumidityLive = false;
                fetch('/fetch_json_data', {method: 'GET'})
                .then(response => response.json())
                .then(data => {
                    const timestamps = data.map(d => new Date(d.time));
                    tempGraph.data.labels = timestamps;
                    tempGraph.data.datasets[0].data = data.map(d => d.temperature);
                    tempGraph.update();

                    humidityGraph.data.labels = timestamps;
                    humidityGraph.data.datasets[0].data = data.map(d => d.humidity);
                    humidityGraph.update();
                })
                .catch(error => alert('Error: ' + error));
            });

            $('#control-reset-humid').click(function() {
                clearChart(humidityGraph); 
                showHumidityLive = !showHumidityLive; 
            });

            $('#control-db').click(function() {
                clearChart(tempGraph);
                clearChart(humidityGraph);
                showTempLive = false; 
                showHumidityLive = false;
                fetch('/fetch_db_data', {method: 'GET'})
                .then(response => response.json())
                .then(data => {
                    const timestamps = data.map(d => new Date(d.time));
                    tempGraph.data.labels = timestamps;
                    tempGraph.data.datasets[0].data = data.map(d => d.temperature);
                    tempGraph.update();

                    humidityGraph.data.labels = timestamps;
                    humidityGraph.data.datasets[0].data = data.map(d => d.humidity);
                    humidityGraph.update();
                })
                .catch(error => alert('Error: ' + error));
            });

            $('#control-humidity').click(function() {
                showHumidityLive = !showHumidityLive; 
                clearChart(humidityGraph);
                if (showHumidityLive) {
                    $('#control-humidity').text('STOP HUMIDITY');
                } else {
                    $('#control-humidity').text('START HUMIDITY');
                }
            });

            $('#control-temperature').click(function() {
                clearChart(tempGraph);
                showTempLive = !showTempLive; 
                if (showTempLive) {
                    $('#control-temperature').text('STOP TEMPERATURE');
                } else {
                    $('#control-temperature').text('START TEMPERATURE');
                }
            });

        });
    </script>
</body>
</html>
